% % % % Parametros de suavizacao:
% % % 
% 0 < parametro > 1;
%  
% Loess - Mais proximo de 1 suaviza mais.
%  
% Spline - Mais proximo de 0 suaviza mais. 
%
% Butter - 0 - 100 quanto maior for o valor menos suaviza
% 
% span parametro do loess - exemplo: 0.5
% fc parametro do butter - exemplo: 10
% p parametro do splines - exemplo: 0.1

function [datsmooth,vel,acel] = rloesplg(dat,span,fc,p,freq)


% freq = 29.97;% frequencia 
nlin = size(dat,1); % numero de linhas
ncol = size(dat,2); % numero de colunas
temp = [(0:nlin-1)/freq]'; % vetor tempo



points = nlin; % numero de linhas no dado suavizado

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% #########################################################################
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% suavizando por rloess %%%%%%%%%%%%%%%%%


for i = 2:ncol;

   datloe(:,i) = smooth(dat(:,1),dat(:,i),span,'rloess'); % suavizando por rloess
    
end

datloe = [dat(:,1),datloe(:,2:ncol)]; % matriz suavizada com o vetor tempo na 1 coluna 

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% #########################################################################
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % Suavizando por butter 
datbutter = filtbutter(datloe,fc,freq);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% #########################################################################
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%% suavizando por spline cubico %%%%%%%%%%%%%%%%%


x = [1:nlin];

xx = linspace(1,nlin,points);

for i = 2:ncol;
    
datspl(i,:) = csaps(x,datbutter(:,i),p,xx);

end

datsmooth = datspl';




%%%%%%%%%%%%%%%%%%%% Calculando os residuos %%%%%%%%%%%%%%%%%%%

res = dat-datsmooth;

%%%%%%%%%%%% suavizando os residuos por rloess %%%%%%%%%%%%%%%%%%


for i = 2:ncol;

   resloe(:,i) = smooth(dat(:,1),res(:,i),span,'rloess'); % suavizando por rloess
    
end

resloe = [dat(:,1),res(:,2:ncol)]; % matriz suavizada com o vetor tempo na 1 coluna 

% % Filtro de butter no residuo
resbutter = filtbutter(resloe,fc,freq);

%%%%%%%%%%%% suavizando os residuos por splines %%%%%%%%%%

for i = 2:ncol;
    
resspl(i,:) = csaps(x,resbutter(:,i),p,xx);

end

resmooth = resspl';

%%%%%%%%%%%%%%%%%% graficos %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i = 2:ncol;

    figure
    

pp = csaps(x,datsmooth(:,i),1);

pv = fnder(pp);

vel = fnval(pv,xx);
vel_t = vel/(1/freq);

pa = fnder(pp,2);

acel = fnval(pa,xx);
acel_t = acel/((1/freq)^2);


% % Metodo por diferena funo diff
vel2 = diff(datsmooth)/(1/freq);
acel2 = diff(vel2)/(1/freq);





subplot(2,2,1)

graf1 = plot(temp,dat(:,i),'r.','MarkerSize',12);
hold on

graf2 = plot(temp,datloe(:,i),'g','LineWidth',4); % plot do ajuste por rloess
hold on

graf3 = plot(temp,datbutter(:,i),'b','LineWidth',2); % plot do ajuste por butter
hold on

graf4 = plot(temp,datsmooth(:,i),'k','LineWidth',1); % plot do ajuste por splines
hold on

legend([graf1,graf2,graf3,graf4],'bruto','rloess','butter','splines')

% plot(temp,datloe(:,i),'k','LineWidth',1)

xlabel('t[s]')
ylabel('[m]')
title('POSIAO') 
axis tight

subplot(2,2,2)

plot(temp,res(:,i),'.r')

hold on

plot(temp,resmooth(:,i))

line([0,max(temp)],[0,0])
max_desv_abs_res = roundn(mad(res(:,i)),-3);




xlabel('t[s]')
ylabel('[m]')
title(['RESDUOS (MAD = ',num2str(max_desv_abs_res),')']) 
axis tight
subplot(2,2,3)

plot(temp,vel_t,'k','LineWidth',2)
hold on
% plot(temp(2:end),vel2,'r','LineWidth',2)

line([0,max(temp)],[0,0])
xlabel('t[s]')
ylabel('[m/s]')
title('VELOCIDADE')
axis tight
subplot(2,2,4)

plot(temp,acel_t,'k','LineWidth',2)
hold on
% plot(temp(3:end),acel2,'r','LineWidth',2)

line([0,max(temp)],[0,0])
xlabel('t[s]')
ylabel('[m/s^2]')
title('ACELERAAO')
axis tight

end
datsmooth = [temp,datsmooth(:,2:ncol)];











function [datf] = filtbutter(dat,fc,freq)
if nargin == 2; freq = 29.97;end

n=4; %ordem do filtro

wn=fc/(freq/2);   %frequencia de corte de

[b,a] = butter(n,wn); %definindo o tipo de filtro Butterworth

ncol = size(dat,2);

for i = 1:ncol;
datf(:,i) = filtfilt(b,a,dat(:,i));

end

datf = [dat(:,1),datf(:,2:end)];
